#!/bin/bash
# Autor: Ivanvega (ivanvegacbr@gmail.com)
# psx2psp.sh COMMAND

version="3.64"
	
appname=$(basename "$0")
appname=$appname" v"$version
basedir=$(dirname "$0")
iconobase="psx2pspicon.png"
datapsp="$basedir/../share/apps/kpopsconverter/DATA.PSP"
KEYS="$basedir/../share/apps/kpopsconverter/KEYS.BIN"
picdir="$basedir/../share/apps/kpopsconverter/pictures"
bootlogo="$picdir/bootlogo.png"
kpopslogo="$picdir/psx2psp2.png"
#Search caption icon

[ -s "/usr/share/icons/$iconobase" ] && icono="/usr/share/icons/$iconobase" 
[ -s "$HOME/.kde/share/icons/$iconobase" ] && icono="$HOME/.kde/share/icons/$iconobase" 
kdeinstalldir=`kde-config --prefix`
[ -s "$kdeinstalldir/share/icons/$iconobase" ] && icono="/opt/kde3/share/icons/$iconobase" 
[ -s "../share/apps/kpopsconverter/pictures/$iconobase" ] && icono="../share/apps/kpopsconverter/pictures/$iconobase"

#Set language from $LANG variable
lengua=$(echo "$LANG" | cut -d"_" -f 1)
if [ "$lengua" != "es" ] && [ "$lengua" != "ca" ];then
	lengua="en"
fi
#For testing language files
#lengua="en"

[ -r "../share/apps/kpopsconverter/psx2psp.$lengua" ] && . "../share/apps/kpopsconverter/psx2psp.$lengua"

popslog="$HOME/copstation.log"

if [ -e "$popslog" ];then
	rm "$popslog"
fi

cdrdaolog="$HOME/cdrdao.log"

if [ -e "$cdrdaolog" ];then
	rm "$cdrdaolog"
fi

# ----------------------------------------------------------
# COMMUNICATION ROUTINES FOR USE WITH KOMMANDER GUI
# ----------------------------------------------------------

# Set the currently executing task to $1.

UpdateTask ()
{
 if [ -n "$DialogDCOPTaskCommand" ]; then
  $DialogDCOPTaskCommand "$1"
 fi
}

# Set the currently executing task to $1.

UpdateProgress ()
{
 if [ -n "$DialogDCOPProgressCommand" ]; then
   $DialogDCOPProgressCommand $1
 fi
}

# ----------------------------------------------------------
# INTERNAL FUNCTIONS
# ----------------------------------------------------------

die () {
  kdialog --icon "$icono" --error "$1. $M_ERROR."
  exit 1
}

FileSize(){
	
	stat -c %s "$1"
}

DisplayCopsEncodingProgress(){
     while ps -e | grep "$pid " >/dev/null
      do
        percentage=$(tail -c 30 "$1" | cut -d"(" -f 2 | cut -d"%" -f 1)
        [ -n "$percentage" ] || percentage=0
        UpdateProgress $percentage
        sleep 1
      done
      UpdateProgress 100
}

DisplayPopsEncodingProgress(){
     while ps -e | grep "$pid " >/dev/null
      do
        bytesCompleted=$(FileSize "$1")
        [ -n "$bytesCompleted" ] || bytesCompleted=0
        percentage=$((100*$bytesCompleted/$tamano))
	UpdateProgress $percentage
        sleep 1
      done
      UpdateProgress 100
}

CrearPsxIso (){
  DialogDCOPProgressCommand="dcop $Kmdr KommanderIf setText ProgressBar_1"
  DialogDCOPTaskCommand="dcop $Kmdr KommanderIf setText StatusBar_1"

  dcop $Kmdr KommanderIf setEnabled ExecButton1 false
  dcop $Kmdr KommanderIf setEnabled ExecButton7 false
  dcop $Kmdr KommanderIf setEnabled ExecButton20 false
  dcop $Kmdr KommanderIf setEnabled ExecButton21 false
  
  [ -b "$dispositivo" ] || die "$M_ERROR_DISP"
  if [ -e "$OUT/ISO.TOC" ];then
	rm "$OUT/ISO.TOC"
  fi
  UpdateProgress 0
  UpdateTask "$M_READ_TOC"
  cdrdao read-toc --fast-toc --read-raw --device "$dispositivo" --driver generic-mmc-raw "$OUT/temp-$shortname.toc"
  tamano=$(cat "$OUT/temp-$shortname.toc" | grep length | awk -F"length in bytes: " {'printf $2'})
  #MinSegTotal=$(cat "$OUT/temp-$shortname.toc" | grep "[0-9][0-9]:[0-9][0-9]:[0-9][0-9]" | cut -d" " -f 3 | awk -F ":" {'printf $1$2'})
  rm "$OUT/temp-$shortname.toc"
  UpdateTask "$M_CREAR_BIN"
  cdrdao read-cd --read-raw --datafile "$title" --device "$dispositivo" --driver generic-mmc-raw "$OUT/ISO.TOC" 2> /dev/null &
  pid=$!
  DisplayPopsEncodingProgress "$title"
  pid=
  #rm "$cdrdaolog"
  UpdateTask "$M_FINISH"
  dcop $Kmdr KommanderIf setEnabled ExecButton1 true
  dcop $Kmdr KommanderIf setEnabled ExecButton7 true
  dcop $Kmdr KommanderIf setEnabled ExecButton20 true
  dcop $Kmdr KommanderIf setEnabled ExecButton21 true
}

SearchGameCode(){
	DialogDCOPTaskCommand="dcop $Kmdr KommanderIf setText StatusBar_2"
	UpdateTask "$M_SEARCHING"
	nice -10 copstation221 -gameid "$title"
	mv -f "gameid.dat" "$OUT"
	gamecode=$(cat "$OUT/gameid.dat")
	if [ -z "$gamecode" ];then
		dcop $Kmdr KommanderIf setEnabled CheckBox1 true
		dcop $Kmdr KommanderIf setChecked CheckBox1 false
		UpdateTask "ERROR!!!. $K_VIEWOUT"
		die "$(cat "$popslog")"
	else
		echo "gamecode=\"$gamecode\"" >> "$OUT/psx2psp.dat"
		$DialogDCOPTextCommand LineEdit2 "$gamecode"
		UpdateTask "$M_FINISH"	
	fi
	
}
CrearManualFromDir(){
if [ -z "$encdir" ];then
	# select destination directory, use last selected
	encdir=$(kdialog --icon "$icono" --title "$M_WHEREIMG" --getexistingdirectory $HOME)
	# encdir not readable?
	test -z "$encdir" && exit
	test ! -r "$encdir" && die "$M_NOREAD2"
	
fi
	zeros="000"
	Imagenes=( $(ls "$encdir" --format=horizontal --format=commas | sed -e 's/,//g') )
	Imagen=0
	UpdateTask "$M_GEN_MAN"
	#BAR=`kdialog --progressbar "$M_GEN_MAN" 2 --icon image --caption "$appname" 2> /dev/null`
	#dcop $BAR setAutoClose 1
	mkdir "$encdir/PNGS"
	while [ -n "${Imagenes[$Imagen]}" ] && [ $Imagen -le 1000 ]
	do
		UpdateTask "$M_GEN_MAN ($Imagen)"
		nice -10 convert "$encdir/${Imagenes[$Imagen]}" -strip -type TrueColor -format PNG -sample 480x272\! -depth 8 "$encdir/PNGS/${zeros}${Imagen}.PNG"
		[ $Imagen -ge 9 ] && zeros="00"
		[ $Imagen -ge 99 ] && zeros="0"
		[ $Imagen -ge 999 ] && zeros=""
		Imagen=$[$Imagen + 1]
	done
	UpdateProgress 75
	DOCMAKER=$(which docmaker303OE)
	DOCMAKEREXE=$(basename "$DOCMAKER")
	#cp -u "$DOCMAKER" "$TMPDIR"
	cd "$TMPDIR"
	nice -10 "$DOCMAKEREXE" "$1" "$encdir/PNGS"
	UpdateProgress 100
	#dcop $BAR setProgress 2

	if [ -e "$TMPDIR/DOCUMENT.DAT" ];then
		mv -f "$TMPDIR/DOCUMENT.DAT" "$mandir"
		rm -r "$encdir/PNGS"
		#rm "$TMPDIR/$DOCMAKEREXE"
	else
		#die "$(cat "$popslog")"
		UpdateTask "ERROR!!!. $K_VIEWOUT"
	fi
}
CrearImagesFromPdf(){
[ -n "$(which pdftoppm)" ] || die "pdftoppm (PDFToolKit) $M_NOTFOUNDIN $PATH"	
	pdfile=$HOME
	pdfile=$(kdialog --icon "$icono" --caption "$M_SELECT MANUAL PDF" --getopenfilename $pdfile "*.pdf & *.ps")
	test -z "$pdfile" && exit
	# file not readable?
	test ! -r "$pdfile" && die "$M_NOEXIST"
	mkdir "$mandir/$pdfdir"
	cd "$mandir/$pdfdir"
	UpdateTask "$M_GEN_PPM"
	#BAR=`kdialog --icon "$icono" --progressbar "$M_GEN_PPM" 1 --icon image --caption "$appname" 2> /dev/null`
	#dcop $BAR setAutoClose 1
	if [ "$(echo $pdfile|sed 's/\.[Pp][Ss]$//g')" != "$pdfile" ]
	then
		nice -10 convert -page Letter "$pdfile" MAN%03d.PNG
	else
		if [ "$(echo $pdfile|sed 's/\.[Pp][Dd][Ff]$//g')" != "$pdfile" ];then	
			nice -10 pdftoppm "$pdfile" MAN
		else
			UpdateProgress 50
			#dcop $BAR setProgress 1
			die 'No PDF/PS'
		fi
	fi
	UpdateProgress 50
	#dcop $BAR setProgress 1
}
CrearManual(){
DialogDCOPProgressCommand="dcop $Kmdr KommanderIf setText ProgressBar_4"
DialogDCOPTaskCommand="dcop $Kmdr KommanderIf setText StatusBar_4"

man=$(kdialog --icon "$icono" --title "$appname" --menu "$M_CREATE_MAN" PDF "$M_MAN_FROM_PDF" DIR "$M_MAN_FROM_DIR" 2> /dev/null)
test -z "$man" && exit
kdialog --icon "$icono" --title "$appname" --yesno "$K_GAME_CODE [$gamecode] . $M_QISCORRECT" 2> /dev/null
generar=$?
if [ "${generar}" = "0" ];then   # 1 means no
	dcop $Kmdr KommanderIf setEnabled LineEdit2 false
	dcop $Kmdr KommanderIf setEnabled CheckBox1 false
	#mkdir "$OUT/$gamecode"
	mandir=$(kdialog --icon "$icono" --title "$appname - $M_SAVE_DIR DOCUMENT.DAT" --getexistingdirectory "$HOME")
	test -z "$mandir" && exit
	test ! -w "$mandir" && die "$M_NOWRITE"
else
	dcop $Kmdr KommanderIf setEnabled LineEdit2 true
	exit
fi
UpdateProgress 0
case "$man" in
	PDF)
		pdfdir="PDF"
		CrearImagesFromPdf
		encdir="$mandir/$pdfdir"
		CrearManualFromDir "$gamecode"
		rm -r "$mandir/$pdfdir"
		UpdateTask "$M_FINISH"
	;;
	DIR)
		CrearManualFromDir "$gamecode"
		UpdateTask "$M_FINISH"
	;;
esac

}

RunChecks(){
# sanity check helper apps
[ -n "$(which kdialog)" ] || die "KDIALOG $M_NOTFOUNDIN $PATH"
[ -n "$(which cdrdao)" ] || die "CDRDAO $M_NOTFOUNDIN $PATH"
[ -n "$(which convert)" ] || die "convert (ImageMagick) $M_NOTFOUNDIN $PATH"
[ -n "$(which copstation221)" ] || die "copstation v2.21 $M_NOTFOUNDIN $PATH"
if [ -z "$(copstation221 2>/dev/null | grep 'compression')" ]; then
	die "$M_NOPOPS"
fi
[ -n "$(which docmaker303OE)" ] || die "docmaker v3.03-OE $M_NOTFOUNDIN $PATH"
[ -n "$(which paladin2ntsc120)" ] || die "paladin2ntsc v1.2 $M_NOTFOUNDIN $PATH. $M_REINSTALL"

}
CrearImagenes (){
if [ "$1" != "multi" ];then	
	IN=$HOME
	IN=$(kdialog --icon "$icono" --caption "$M_SELECT $M_IMGCONV << $1 >>" --getopenfilename $IN "*.bmp & *.jpg & *.jpeg & *.gif & *.tiff & *.png")
	test -z "$IN" && exit
	# file not readable?
	test ! -r "$IN" && die "$M_NOEXIST"
fi
	#reemplazar "'" por "`"
	caracter=$(echo "$gametitle" | grep "'")
	if [ -n "$caracter" ];then
		#echo "Arreglo..."
		gametitle=$(echo "$gametitle" | awk -F "'" {'printf $1"`"$2'})
	fi
	case "$1" in
	icono) nice -10 convert "$IN" -strip -type TrueColor -format PNG -filter Triangle -resize 144x80! -depth 8 "$OUT/ICON0.PNG";;
	portada) nice -10 convert "$IN" -strip -type TrueColorMatte -format PNG -sample 310x180\! -depth 8 "$OUT/PIC0.PNG";;
	fondo) nice -10 convert "$IN" -strip -type TrueColorMatte -format PNG -filter Triangle -resize 480x272! -depth 8 "$OUT/PIC1.PNG";;
	boot) 
		nice -10 convert "$IN" -strip -filter Triangle -resize 480x272! "$OUT/LOGO.RAW"
		nice -10 convert -size 480x272 "$OUT/LOGO.RAW" "$OUT/LOGO.PGM"
		nice -10 convert "$OUT/LOGO.PGM" "$OUT/LOGO.PNG"
		rm "$OUT/LOGO.PGM" "$OUT/LOGO.RAW"
		;;
	multi)
		if [ ! -s "$OUT/ICON0_NO_DISC.PNG" ];then
			mv "$OUT/ICON0.PNG" "$OUT/ICON0_NO_DISC.PNG"
		fi
		numdisc=$discos
		while [ $discos -ne 0 ]
		do
			if [ $disco -eq $discos ];then
				cp "$picdir/cd.png" "$TMPDIR/cd_$discos.png"
			else
				nice -10 convert "$picdir/cd.png" -type GrayscaleMatte "$TMPDIR/cd_$discos.png"
			fi
			discos=$[$discos - 1]
		done
		nice -10 montage "$TMPDIR/cd_[1-$numdisc].png" -tile x1 -background none -geometry x16-2+0 "$TMPDIR/tile1.png"
		nice -10 composite "$TMPDIR/tile1.png" -geometry +3+3 -gravity southeast "$OUT/ICON0_NO_DISC.PNG" "$OUT/ICON0.PNG"
	;;
	*) nice -10 convert -font "$fuente" -pointsize 30\
	 -fill black -draw "text 17,52 '$gametitle'"\
	 -fill white -draw "text 15,50 '$gametitle'"\
	 -font helvetica -pointsize 15\
	 -fill black -draw "text 19,74 '$gamecode'"\
	 -fill white -draw "text 17,72 '$gamecode'"\
	 "$baseimg" -strip -colors 256 -depth 8 "$OUT/PIC0.PNG";;
	esac
}
CrearIcono(){
if [ -z $(ls "$OUT" | grep ICON0.PNG) ];then
	CrearImagenes "icono"
	$DialogDCOPTextCommand PixmapLabel1 "$OUT/ICON0.PNG"
else
	die "$M_DEL_IMAGE"
fi
}
CrearFondo(){
if [ -z $(ls "$OUT" | grep PIC1.PNG) ];then
	CrearImagenes "fondo"
	$DialogDCOPTextCommand PixmapLabel2 "$OUT/PIC1.PNG"
else
	die "$M_DEL_IMAGE"
fi
}
CrearBoot(){
if [ -z $(ls "$OUT" | grep LOGO.PNG) ];then
	CrearImagenes "boot"
	$DialogDCOPTextCommand PixmapLabel2_2 "$OUT/LOGO.PNG"
else
	die "$M_DEL_IMAGE"
fi
}
CrearMulti(){
if [ -s "$OUT/ICON0.PNG" ];then
	CrearImagenes "multi"
	$DialogDCOPTextCommand PixmapLabel1 "$OUT/ICON0.PNG"
else
	die "$K_SET $K_ICON"
fi
}
PreviewPSPScreen(){
actualdir=$(pwd)
cd "../share"
screenpsp=`find "$(pwd)/apps/kpopsconverter" -iname "screenpsp.png" -printf "%h/%f\n"`
test ! -s "$screenpsp" && die "$M_PREVIEW_HELPER. $M_NOEXIST"
cd "$OUT"
if [ -s "$screenpsp" ];then
	nice -10 composite "$screenpsp" PIC1.PNG preview.png
else
	kdialog --icon "$icono" --warningcontinuecancel " screenpsp.png. $M_NOEXIST"
	nice -10 convert PIC1.PNG preview.png
fi
nice -10 composite -geometry 144x80+20+96  ICON0.PNG preview.png preview.png
nice -10 composite -geometry 310x180+165+87 PIC0.PNG preview.png preview.png
}
CrearPreview(){
if [ -n "$(ls "$OUT" | grep ICON0.PNG)" ] && [ -n "$(ls "$OUT" | grep PIC0.PNG)" ] && [ -n "$(ls "$OUT" | grep PIC1.PNG)" ];then
	PreviewPSPScreen
	$DialogDCOPTextCommand PixmapLabel7 "$OUT/preview.png"
else
	echo "$M_MISSING"
fi
}
Pal2Ntsc(){
#shortname=$(echo $filename|sed 's/\..*$//g') # delete suffix
ext=$(echo "$filename" | awk -F"." {'printf $NF'})
shortname=$(basename "$filename" ".$ext") # delete suffix
ntscname="${shortname}NTSC.${ext}"
if [ -e "$OUT/$ntscname" ];then
	rm "$OUT/$ntscname"
fi

tamano=$(FileSize "$OUT/$filename")
UpdateTask "$M_CONVERT <$filename> $M_TO <$ntscname>"
nice -10 paladin2ntsc120 "$OUT/$filename" "$OUT/$ntscname" &
pid=$!
DisplayPopsEncodingProgress "$OUT/$ntscname"
pid=
if [ -s "$OUT/$ntscname" ];then
	UpdateTask "$M_FINISH"
	filename="$ntscname"
fi
}
CrearPops(){
DialogDCOPProgressCommand="dcop $Kmdr KommanderIf setText ProgressBar_5"
DialogDCOPTaskCommand="dcop $Kmdr KommanderIf setText StatusBar_5"
dcop $Kmdr KommanderIf setEnabled ExecButton1 false

POPS=$(which copstation221)
POPSEXE=$(basename "$POPS")

test -z $compress && compress=0
makedoc=1
if [ "$firmware" = "3.02 OE-B" ];then
	test ! -r "$datapsp" && die "DATA.PSP - $M_NOFOUND2. $M_REINSTALL"
	test ! -r "$KEYS" && die "KEYS.BIN - $M_NOFOUND2. $M_REINSTALL"
	cp -u "$datapsp" "$OUT"
	cp -u "$KEYS" "$OUT"
	compress=0
	makedoc=
fi

if [ "$firmware" = "< 3.03 OE-C" ];then
	test ! -r "$datapsp" && die "DATA.PSP - $M_NOFOUND2. $M_REINSTALL"
	test ! -r "$KEYS" && die "KEYS.BIN - $M_NOFOUND2. $M_REINSTALL"
	cp -u "$datapsp" "$OUT"
	cp -u "$KEYS" "$OUT"
fi

if [ $pal -eq 1 ];then
	Pal2Ntsc
fi

cp -u "$POPS" "$OUT"
tamano=$(FileSize "$OUT/$filename")
tamanoMB=$((($tamano/(1024*1024))))
cd "$OUT"
UpdateTask "$M_CONVERT <$filename> $M_TO EBOOT.PBP"
nice -10 "$POPSEXE" "$gametitle" "$gamecode" "$compress" "$filename" > "$popslog" &
pid=$!
if [ $compress -eq 0 ];then
	DisplayPopsEncodingProgress "$OUT/EBOOT.PBP"
else
	DisplayCopsEncodingProgress "$popslog"
fi
pid=
rm "$OUT/$POPSEXE"
#rm "$OUT/BASE.PBP"

if [ -e "$OUT/DATA.PSP" ];then
	rm "$OUT/DATA.PSP"
fi

test -z $disco && disco=1
test -z $discos && discos=1

if [ -s "$OUT/EBOOT.PBP" ];then
	mkdir "$OUT/$gamecode DISC${disco}OF${discos}"
	mv -f "$OUT/EBOOT.PBP" "$OUT/$gamecode DISC${disco}OF${discos}"
	if [ -e "$OUT/KEYS.BIN" ];then
		mv -f "$OUT/KEYS.BIN" "$OUT/$gamecode DISC${disco}OF${discos}"
	fi
	if [ $makedoc ];then
		dcop $Kmdr KommanderIf setEnabled ExecButton2 true
	else
		dcop $Kmdr KommanderIf setEnabled ExecButton2 false
	fi

	dcop $Kmdr KommanderIf setEnabled ExecButton33 true
	dcop $Kmdr KommanderIf setEnabled LineEdit2 false
	UpdateTask "$M_FINISH. $M_COPY_PSP >>$gamecode DISC${disco}OF${discos}<<"
	rm "$popslog"
	return 0
else
	UpdateTask "ERROR!!!. $K_VIEWOUT"
	die "$(cat "$popslog")"
fi
dcop $Kmdr KommanderIf setEnabled ExecButton1 true

}
TransferGame(){
DialogDCOPProgressCommand="dcop $Kmdr KommanderIf setText ProgressBar_5"
DialogDCOPTaskCommand="dcop $Kmdr KommanderIf setText StatusBar_5"
# select destination directory, use last selected
PSProot=$(kdialog --title "$M_PSPROOT" --getexistingdirectory "/media")
test -z "$PSProot" && exit
test ! -w "$PSProot" && die "$M_NOWRITE"

test ! -d "$PSProot/PSP/GAME/" && die "$M_NOPSPROOT"

test -z $disco && disco=1
test -z $discos && discos=1

if [ -s "$OUT/$gamecode DISC${disco}OF${discos}/EBOOT.PBP" ];then
	UpdateTask "$M_MOVE_GAME"
	if [ -s "$PSProot/PSP/GAME/$gamecode DISC${disco}OF${discos}/EBOOT.PBP" ];then
		kdialog --yesno "$gamecode DISC${disco}OF${discos}. $M_EXIST. $M_OVERWRITE" 2> /dev/null
		overwrite=$?
		if [ "${overwrite}" = "0" ];then   # 1 means no
			tamano=$(FileSize "$OUT/$gamecode DISC${disco}OF${discos}/EBOOT.PBP")
			rm -r "$PSProot/PSP/GAME/$gamecode DISC${disco}OF${discos}" 
			mv "$OUT/$gamecode DISC${disco}OF${discos}" "$PSProot/PSP/GAME/" &
			pid=$!
			DisplayPopsEncodingProgress "$PSProot/PSP/GAME/$gamecode DISC${disco}OF${discos}/EBOOT.PBP"
			pid=
		else
			exit
		fi
	else
		tamano=$(FileSize "$OUT/$gamecode DISC${disco}OF${discos}/EBOOT.PBP")
		mv "$OUT/$gamecode DISC${disco}OF${discos}" "$PSProot/PSP/GAME/" &
		pid=$!
		DisplayPopsEncodingProgress "$PSProot/PSP/GAME/$gamecode DISC${disco}OF${discos}/EBOOT.PBP"
		pid=
		#kdialog --msgbox "$OUT/$gamecode DISC${disco}OF${discos}/EBOOT.PBP $M_NOEXIST"
	fi
	#kfmclient move "$OUT/$gamecode DISC${disco}OF${discos}" "$PSProot/PSP/GAME/"
	UpdateTask "$M_FINISH"
else
	if [ -s "$PSProot/PSP/GAME/$gamecode DISC${disco}OF${discos}/EBOOT.PBP" ];then
		kdialog --msgbox "$gamecode DISC${disco}OF${discos}. $M_EXIST"
	else
		kdialog --msgbox "$OUT/$gamecode DISC${disco}OF${discos}/EBOOT.PBP $M_NOEXIST"
	fi
fi
}
#################
#Script begin   #
#################
OUT="$2"
Kmdr="$3"
DialogDCOPTextCommand="dcop $3 KommanderIf setText"

# import configuration file
[ -r "$OUT/psx2psp.dat" ] && . "$OUT/psx2psp.dat"

if [ -z "$gamecode" ];then
	gamecode="$4"
fi


if [ -z "$Command" ];then
	Command="$1"
fi

if [ "$Command" == "RunChecks" ];then
	$DialogDCOPTextCommand "Label200" "$K_L200"
	$DialogDCOPTextCommand "Label210" "$K_L210"
	$DialogDCOPTextCommand "Label201" "$K_L201"
	$DialogDCOPTextCommand "Label211" "$K_L211"
	$DialogDCOPTextCommand "Label203" "$K_L203"
	$DialogDCOPTextCommand "Label213" "$K_L213"
	$DialogDCOPTextCommand "Label204" "$K_L204"
	$DialogDCOPTextCommand "Label214" "$K_L214"
	$DialogDCOPTextCommand "Label205" "$K_L205"
	$DialogDCOPTextCommand "Label215" "$K_L215"
	$DialogDCOPTextCommand "ExecButton9" "$K_CREATE_IMAGE_FROM"
	$DialogDCOPTextCommand "ExecButton10" "$K_READ CD-ROM"
	$DialogDCOPTextCommand "ExecButton1" "$M_SELECT $K_IMAGE"
	$DialogDCOPTextCommand "Label2" "$K_GAME_TITLE"
	$DialogDCOPTextCommand "ExecButton2" "$K_MAKE DOCUMENT.DAT"
	$DialogDCOPTextCommand "Label3" "$K_GAME_CODE"
	$DialogDCOPTextCommand "CheckBox1" "$K_AUTODETECT"
	$DialogDCOPTextCommand "ExecButton5" "$K_SET $K_ICON"
	$DialogDCOPTextCommand "ExecButton6" "$K_REMOVE $K_ICON"
	$DialogDCOPTextCommand "CheckBox2" "$K_COMPRES $K_LEVEL"
	$DialogDCOPTextCommand "ExecButton3" "$K_SET ICON1.PMF"
	$DialogDCOPTextCommand "ExecButton4" "$K_SET SND0.AT3"
	$DialogDCOPTextCommand "ExecButton7" "$K_START_CONV"
	$DialogDCOPTextCommand "ExecButton22" "$K_SET $K_BACKGROUND"
	$DialogDCOPTextCommand "ExecButton23" "$K_REMOVE $K_BACKGROUND"
	$DialogDCOPTextCommand "Label15" "$M_SELECT $K_IMAGE_BASE"
	$DialogDCOPTextCommand "ExecButton25" "$K_ADD_CUSTOM_BACK"
	$DialogDCOPTextCommand "CheckBox5" "$K_CUSTOM_FONTS"
	$DialogDCOPTextCommand "CheckBox6" "$K_CUSTOM_COLORS"
	$DialogDCOPTextCommand "ExecButton120" "$K_GEN"
	$DialogDCOPTextCommand "ExecButton23_3" "$K_GEN"
	$DialogDCOPTextCommand "Label14" "$K_GAME_TITLE_FONT"
	$DialogDCOPTextCommand "ColorTitle" "$K_FONT_COLOR"
	$DialogDCOPTextCommand "ShadowColorTitle" "$K_SHADOW"
	$DialogDCOPTextCommand "Label13" "$K_GAME_CODE_FONT"
	$DialogDCOPTextCommand "ColorCode" "$K_FONT_COLOR"
	$DialogDCOPTextCommand "ShadowColorCode" "$K_SHADOW"
	$DialogDCOPTextCommand "ExecButton24" "$K_GEN $K_PREVIEW"
	$DialogDCOPTextCommand "StatusBar_1" "$K_STATUS"
	$DialogDCOPTextCommand "StatusBar_2" "$K_STATUS"
	$DialogDCOPTextCommand "StatusBar_4" "$K_STATUS"
	$DialogDCOPTextCommand "StatusBar_5" "$K_STATUS"
	$DialogDCOPTextCommand "ExecButton33" "$K_TRANSFER"
	$DialogDCOPTextCommand "PixmapLabel2_2" "$bootlogo"
	$DialogDCOPTextCommand "FirmwareLabel" "$K_SEL_FIRMWARE"
	$DialogDCOPTextCommand "ExecButton22_2" "$K_SET_BOOT"
	$DialogDCOPTextCommand "ExecButton23_2" "$K_UNSET_BOOT"
	$DialogDCOPTextCommand "CheckPal" "$K_CheckPal"
	$DialogDCOPTextCommand "Label26" "$K_OF"

	RunChecks
else
	RunChecks
	"$Command"
fi

