#!/bin/bash

InstallDir="$2"
ApplicationDir="$2/share/applications/kde"
DesktopFile="$ApplicationDir/KPops Converter.desktop"
Pops="$(which copstation221)"
Docmaker="$(which docmaker303OE)"
Paladin="$(which paladin2ntsc120)"
Gcc="$(which gcc)"

if [ -x "$Gcc" ];then

if [ -z "$Pops" ];then
	cd "$1/psptools/copstation-2.21"
	make
	if [ -x "$1/psptools/copstation-2.21/copstation221" ];then
		mv -u "$1/psptools/copstation-2.21/copstation221" "$InstallDir/bin"
		make clean
	else
		kdialog --error "Error making copstation"
		exit
	fi
fi

if [ -z "$Docmaker" ];then
	cd "$1/psptools/docmaker"
	make
	if [ -x "$1/psptools/docmaker/docmaker303OE" ];then
		mv -u "$1/psptools/docmaker/docmaker303OE" "$InstallDir/bin"
		make clean
	else
		kdialog --error "Error making docmaker"
		exit
	fi
fi

if [ -z "$Paladin" ];then
	cd "$1/psptools/pal2ntsc"
	make
	if [ -x "$1/psptools/pal2ntsc/paladin2ntsc120" ];then
		mv -u "$1/psptools/pal2ntsc/paladin2ntsc120" "$InstallDir/bin"
		make clean
	else
		kdialog --error "Error making paladin2ntsc"
		exit
	fi
fi

mkdir -p "$InstallDir"
#for uninstall
echo "InstallDir=\"$InstallDir\"" > "$HOME/.KPOPS_Converter.uninstall"
echo "DesktopFile=\"$DesktopFile\"" >> "$HOME/.KPOPS_Converter.uninstall"

cp -fr "$1/bin" "$1/share" "$InstallDir"

chmod ugo+x "$InstallDir/bin/psx2psp.sh"

echo "[Desktop Entry]" > "$DesktopFile"
echo "Name=KPOPS Converter" >> "$DesktopFile"
echo "GenericName=PSX to PSP Game Converter" >> "$DesktopFile"
echo "Exec=kmdr-executor '$InstallDir/bin/KPOPS_Converter.kmdr'" >> "$DesktopFile"
echo "Type=Application" >> "$DesktopFile"
echo "Icon=psx2pspicon.png" >> "$DesktopFile"
echo "Categories=Qt;KDE;AudioVideo;" >> "$DesktopFile"

else
	kdialog --error "Compiler gcc not found. Required for creating tools. Please install."
fi